//------------------------------------------------------------------------------ 
// Copyright (c) 2004 Xilinx, Inc. 
// All Rights Reserved 
//------------------------------------------------------------------------------ 
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Author: Latha Pillai, Advanced Product Group, Xilinx, Inc.
//  \   \        Filename: FIR_SLICE
//  /   /        Date Last Modified:  June 23, 2004 
// /___/   /\    Date Created: June 23, 2004 
// \   \  /  \ 
//  \___\/\___\ 
// 
//
// Revision History: 
// $Log: $
//------------------------------------------------------------------------------ 
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//------------------------------------------------------------------------------ 
/**********************************************************************/
`timescale  1 ns / 1 ps

module FIR_SLICE1 (CLK, RST, A_IN, C_IN, PCOUT, POUT);
	
input           CLK, RST;
input   [7:0]  A_IN;
input   [7:0]  C_IN;
output  [47:0]  PCOUT, POUT;


//          
// Instantiation block 1
//
  DSP48 DSP48_1 (
      .BCOUT(),  // 18-bit B cascade output
      .P(POUT),          // 48-bit product output
      .PCOUT(PCOUT),  // 38-bit cascade output
      .A({10'b0, C_IN}),          // 18-bit A data input
      .B({10'b0, A_IN}),          // 18-bit B data input
      .BCIN(18'b0),    // 18-bit B cascade input
      .C(48'b0),          // 48-bit cascade input
      .CARRYIN(1'b0), // Carry input signal
      .CARRYINSEL(2'b00), // 2-bit carry input select
      .CEA(1'b1),      // A data clock enable input
      .CEB(1'b1),      // B data clock enable input
      .CEC(1'b0),      // C data clock enable input
      .CECARRYIN(1'b0), // CARRYIN clock enable input
      .CECINSUB(1'b0), // CINSUB clock enable input
      .CECTRL(1'b0), // Clock Enable input for CTRL registers
      .CEM(1'b1),       // Clock Enable input for multiplier registers
      .CEP(1'b1),       // Clock Enable input for P registers
      .CLK(CLK),       // Clock input
      .OPMODE(7'b0000101), // 7-bit operation mode input
      .PCIN(48'b0),     // 48-bit PCIN input
      .RSTA(RST),     // Reset input for A pipeline registers
      .RSTB(RST),     // Reset input for B pipeline registers
      .RSTC(RST),     // Reset input for C pipeline registers
      .RSTCARRYIN(RST), // Reset input for CARRYIN registers
      .RSTCTRL(RST), // Reset input for CTRL registers
      .RSTM(RST), // Reset input for multiplier registers
      .RSTP(RST), // Reset input for P pipeline registers
      .SUBTRACT(1'b0) // SUBTRACT input
   );
  

//synthesis translate_off


   defparam DSP48_1.AREG = 1; // Number of pipeline registers on the 
                              //   A input, 0, 1 or 2
   defparam DSP48_1.BREG = 1; // Number of pipeline registers on the 
                              //   B input, 0, 1 or 2
   defparam DSP48_1.B_INPUT = "DIRECT"; // B input DIRECT from fabric 
                                        //   or CASCADE from another DSP48
   defparam DSP48_1.CARRYINREG = 0; // Number of pipeline registers 
                                    //   for the CARRYIN input, 0 or 1
   defparam DSP48_1.CARRYINSELREG = 0; // Number of pipeline 
                                        //  registers for the CARRYINSEL, 0 or 1
   defparam DSP48_1.CREG = 0; // Number of pipeline registers on the 
                              //   C input, 0 or 1
   defparam DSP48_1.LEGACY_MODE = "MULT18X18S"; // Backward compatibility, NONE,
                                                //   MULT18X18 or MULT18X18S  
   defparam DSP48_1.MREG = 1; // Number of multiplier pipeline 
                              //   registers, 0 or 1
   defparam DSP48_1.OPMODEREG = 0; // Number of pipeline regsiters on 
                                   //   OPMODE input, 0 or 1
   defparam DSP48_1.PREG = 1; // Number of pipeline registers on the 
                              //   P output, 0 or 1
   defparam DSP48_1.SIM_X_INPUT = "GENERATE_X_ONLY";
                             // Simulation parameter for behavior for X on
                              //   input.
                             //   Possible values: GENERATE_X, NONE or WARNING
   defparam DSP48_1.SUBTRACTREG = 0; // Number of pipeline registers 
                                     //   on the SUBTRACT input, 0 or 1

//synthesis translate_on

   // End of DSP48_1 instantiation 

////////////////////////////////////////////////////////////////////////////////////

endmodule



